org.apache.poi.hwpf.model

## Class ListLevel

- java.lang.Object
- - org.apache.poi.hwpf.model.ListLevel

-     @Internal
      public final class ListLevel
      extends java.lang.Object

  "The LVL structure contains formatting information about a specific level in a list. When a paragraph is formatted as part of this level, each placeholder in xst is replaced with the inherited level number of the most recent or current paragraph in the same list that is in the zero-based level specified by that placeholder. The level number that replaces a placeholder is formatted according to the lvlf.nfc of the LVL structure that corresponds to the level that the placeholder specifies, unless the lvlf.fLegal of this LVL structure is nonzero." -- Page 388 of 621 -- [MS-DOC] -- v20110315 Word (.doc) Binary File Format

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ListLevel(byte[] buf, int startOffset)` Deprecated.
    `ListLevel(int level, boolean numbered)`
    `ListLevel(int startAt, int numberFormatCode, int alignment, byte[] numberProperties, byte[] entryProperties, java.lang.String numberText)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `getAlignment()` "Alignment (left, right, or centered) of the paragraph number."
    `byte[]` | `getGrpprlChpx()`
    `byte[]` | `getGrpprlPapx()`
    `byte[]` | `getLevelNumberingPlaceholderOffsets()` Array which specifies the character offsets of the level numbers in a level numbering string.
    `byte[]` | `getLevelProperties()`
    `int` | `getNumberFormat()` "Number format code (see anld.nfc for a list of options)"
    `java.lang.String` | `getNumberText()`
    `short` | `getRestart()` An unsigned integer that specifies the first (most-significant) zero-based level after which the number sequence of this level does not restart.
    `int` | `getSizeInBytes()`
    `int` | `getStartAt()`
    `byte` | `getTypeOfCharFollowingTheNumber()` "The type of character following the number text for the paragraph: 0 == tab, 1 == space, 2 == nothing."
    `int` | `hashCode()`
    `boolean` | `isLegalNumbering()` Determines if the number formatting shall be overridden by `msonfcArabic`; unless it originally was `msonfcArabicLZ` in which case it is preserved.
    `void` | `setAlignment(int alignment)`
    `void` | `setLevelProperties(byte[] grpprl)`
    `void` | `setNumberFormat(int numberFormatCode)`
    `void` | `setNumberProperties(byte[] grpprl)`
    `void` | `setStartAt(int startAt)`
    `void` | `setTypeOfCharFollowingTheNumber(byte value)`
    `byte[]` | `toByteArray()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ListLevel

          @Deprecated
          public ListLevel(byte[] buf,
                                       int startOffset)

      Deprecated.

    - #### ListLevel

          public ListLevel(int level,
                           boolean numbered)

    - #### ListLevel

          public ListLevel(int startAt,
                           int numberFormatCode,
                           int alignment,
                           byte[] numberProperties,
                           byte[] entryProperties,
                           java.lang.String numberText)

  - ### Method Detail

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### getAlignment

          public int getAlignment()

      "Alignment (left, right, or centered) of the paragraph number."

    - #### getGrpprlChpx

          public byte[] getGrpprlChpx()

    - #### getGrpprlPapx

          public byte[] getGrpprlPapx()

    - #### getLevelProperties

          public byte[] getLevelProperties()

    - #### getNumberFormat

          public int getNumberFormat()

      "Number format code (see anld.nfc for a list of options)"

    - #### getNumberText

          public java.lang.String getNumberText()

    - #### getSizeInBytes

          public int getSizeInBytes()

    - #### getStartAt

          public int getStartAt()

    - #### getTypeOfCharFollowingTheNumber

          public byte getTypeOfCharFollowingTheNumber()

      "The type of character following the number text for the paragraph: 0 == tab, 1 == space, 2 == nothing."

    - #### getRestart

          public short getRestart()

      An unsigned integer that specifies the first (most-significant) zero-based level after which the number sequence of this level does not restart. The number sequence of this level does restart after any level that is more significant than the specified level. This MUST be less than or equal to the zero-based level of the list to which this LVLF corresponds.

      see [MS-DOC], v20140721, 2.9.150

      Returns:
        the first (`0` is the most significant) level after which the numbering does not restart or `-1` if no restart is applicable

    - #### isLegalNumbering

          public boolean isLegalNumbering()

      Determines if the number formatting shall be overridden by `msonfcArabic`; unless it originally was `msonfcArabicLZ` in which case it is preserved.

      see [MS-DOC], v20140721, 2.9.150 and [MS-OSHARED], v20140721, 2.2.1.3

      Returns:
        `true` if the level numbering of this and all more significant levels must be overridden; `false` otherwise

    - #### getLevelNumberingPlaceholderOffsets

          public byte[] getLevelNumberingPlaceholderOffsets()

      Array which specifies the character offsets of the level numbers in a level numbering string.

      see [MS-DOC], v20140721, 2.9.150

      Returns:
        `0`-terminated array, unless it is full

    - #### setAlignment

          public void setAlignment(int alignment)

    - #### setLevelProperties

          public void setLevelProperties(byte[] grpprl)

    - #### setNumberFormat

          public void setNumberFormat(int numberFormatCode)

    - #### setNumberProperties

          public void setNumberProperties(byte[] grpprl)

    - #### setStartAt

          public void setStartAt(int startAt)

    - #### setTypeOfCharFollowingTheNumber

          public void setTypeOfCharFollowingTheNumber(byte value)

    - #### toByteArray

          public byte[] toByteArray()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.